Index: trunk/MESOSCALE/LMD_MM_MARS/SRC/WRFV2/mars_lmd/libf/phymars/inifis.F
===================================================================
--- trunk/MESOSCALE/LMD_MM_MARS/SRC/WRFV2/mars_lmd/libf/phymars/inifis.F	(revision 1199)
+++ trunk/MESOSCALE/LMD_MM_MARS/SRC/WRFV2/mars_lmd/libf/phymars/inifis.F	(revision 1202)
@@ -504,4 +504,16 @@
          endif
 
+         READ(99,*)
+         READ(99,*)
+
+         !! prescribed crocus line for caps
+         READ(99,fmt='(a)') ch1
+         READ(99,*,iostat=ierr) tituscap
+         if (ierr.ne.0) then
+           write(*,*) 'no titus cap requested. set it to false'
+           tituscap = .false.
+         endif 
+         WRITE(*,8000) ch1,tituscap
+
          PRINT*,'--------------------------------------------'
          PRINT*
Index: trunk/MESOSCALE/LMD_MM_MARS/SRC/WRFV2/mars_lmd/libf/phymars/physiq.F
===================================================================
--- trunk/MESOSCALE/LMD_MM_MARS/SRC/WRFV2/mars_lmd/libf/phymars/physiq.F	(revision 1199)
+++ trunk/MESOSCALE/LMD_MM_MARS/SRC/WRFV2/mars_lmd/libf/phymars/physiq.F	(revision 1202)
@@ -330,5 +330,4 @@
       integer igmin, lmin
       logical tdiag
-      logical tituscap
 
       REAL zplev(ngrid,nlayermx+1),zplay(ngrid,nlayermx)
@@ -345,4 +344,6 @@
      
 c=======================================================================
+
+
 
 
@@ -1064,12 +1065,15 @@
 c   -------------------------------------------
 
-      tituscap = .true.
+      !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
+      !!! get the actual co2 seasonal cap from Titus observations
+      !!! (inherited from GCM only at first step, but not a big deal)
       IF (tituscap) THEN
-         PRINT*,'TITUS CAP !!!'
-         !!! get the actual co2 seasonal cap from Titus observations
          CALL geticecover( ngrid, 180.*zls/pi,
      .                  180.*long/pi, 180.*lati/pi, co2ice )
-         co2ice = co2ice * 10000.
+         co2ice(:) = co2ice(:)*10000.
+         emis(:) = 0.95 ! so that points outside the cap are indeed at 0.95
+                        ! avoid unwanted patchiness from GCM initial state
       ENDIF
+      !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
 
       IF(callcond) THEN
@@ -1081,4 +1085,6 @@
      $	            fluxsurf_sw) 
 
+         !! Titus cap security. 
+         !! -- neglect pressure changes caused by sublimation/condensation
          IF (tituscap) THEN 
            DO ig=1,ngrid
Index: trunk/MESOSCALE/LMD_MM_MARS/SRC/WRFV2/mars_lmd/libf/phymars/surfini.F
===================================================================
--- trunk/MESOSCALE/LMD_MM_MARS/SRC/WRFV2/mars_lmd/libf/phymars/surfini.F	(revision 1199)
+++ trunk/MESOSCALE/LMD_MM_MARS/SRC/WRFV2/mars_lmd/libf/phymars/surfini.F	(revision 1202)
@@ -37,19 +37,30 @@
                           !! si elles sont consequentes
          enddo
-         if ( ( lati(ig)*180./pi .gt. 70. ) .and.
-     .        ( albedodat(ig) .ge. 0.26   ) )  then
-                 write(*,*)"outlier ",ig,albedodat(ig),inertiedat(ig)
+
+!! AS: my previous stuff
+!         if ( ( lati(ig)*180./pi .gt. 70. ) .and.
+!     .        ( albedodat(ig) .ge. 0.26   ) )  then
+!                 write(*,*)"outlier ",ig,albedodat(ig),inertiedat(ig)
+!                 watercaptag(ig)  = .true.
+!                 dryness(ig)      = 1.
+!                 albedodat(ig)    = 0.45 !albedo_h2o_ice  !! pour output 
+!                 inertiedat(ig)   = 800.
+!                 write(*,*)"new values ",ig,albedodat(ig),inertiedat(ig)
+!         else
+!                 watercaptag(ig)  = .false.
+!                 dryness(ig)      = 1.
+!         endif 
+!         if ( inertiedat(ig) .ge. 800. ) then
+!            write(*,*)"change inertie from ",inertiedat(ig)," to 800."
+!            inertiedat(ig)   = 800.
+!         endif
+
+!! using Tyler and Barnes maps.
+         dryness(ig)      = 1.
+         if ( inertiedat(ig) .ge. 600. ) then
+                 write(*,*)"ice ",ig,albedodat(ig),inertiedat(ig)
                  watercaptag(ig)  = .true.
-                 dryness(ig)      = 1.
-                 albedodat(ig)    = 0.45 !albedo_h2o_ice  !! pour output 
-                 inertiedat(ig)   = 800.
-                 write(*,*)"new values ",ig,albedodat(ig),inertiedat(ig)
          else
                  watercaptag(ig)  = .false.
-                 dryness(ig)      = 1.
-         endif 
-         if ( inertiedat(ig) .ge. 800. ) then
-            write(*,*)"change inertie from ",inertiedat(ig)," to 800."
-            inertiedat(ig)   = 800.
          endif
          
Index: trunk/MESOSCALE/LMD_MM_MARS/SRC/WRFV2/meso_callkeys.h
===================================================================
--- trunk/MESOSCALE/LMD_MM_MARS/SRC/WRFV2/meso_callkeys.h	(revision 1199)
+++ trunk/MESOSCALE/LMD_MM_MARS/SRC/WRFV2/meso_callkeys.h	(revision 1202)
@@ -19,4 +19,5 @@
      .   , sedimentation,iceparty,activice,water,caps
      .   , photochem,nqchem_min
+     .   , tituscap
 
       LOGICAL callrad,calldifv,calladj,callcond,callsoil,
@@ -25,5 +26,5 @@
      s   ,callnirco2,callnlte,callthermos,callconduct,
      s    calleuv,callmolvis,callmoldiff,thermochem,thermoswater
-
+     s   ,tituscap
 
       logical callemis