Index: trunk/MESOSCALE/MANUAL/SRC/advance.tex
===================================================================
--- trunk/MESOSCALE/MANUAL/SRC/advance.tex	(revision 1217)
+++ trunk/MESOSCALE/MANUAL/SRC/advance.tex	(revision 1218)
@@ -145,18 +145,19 @@
 \item the number of scatterers must be given when compiling, standard simulation uses 1 scatterer (2 is used for radiatively active water ice clouds)
 \item in \ttt{namelist.input}, the soil model must set to 18 levels
+\item in \ttt{namelist.input}, the 6th order small scale diffusion must be set to 0 (i.e. \ttt{diff\_6th\_opt = 0}) if the resolution is small ($<10$~km)
 \item additional \ttt{mars} modes can be accessed (e.g. for interactive dust or the radiative effect of clouds)
 \item if \ttt{init\_TI} is modified, \ttt{real.exe} must be run again (because of subsurface modeling)
 \item a varying map for surface roughness~$z_0$ can be used -- or a constant value can be set with \ttt{init\_Z0} in \ttt{namelist.input} (if there is a problem, the old reference of 1cm is chosen)
-\item (versions later than late 2013) the model does not need to be recompiled if the number of tracers is changed
-\item (experimental) cases with tracers and water cycle should use \ttt{diff\_6th\_opt = 0} for better stability
+\item (starting from version \ttt{r1038}) the model does not need to be recompiled if the number of tracers is changed
+\item (starting from version \ttt{r1214}) the model does not need to be recompiled if the number of horizontal grid points or the number of processors is changed
 \end{finger}
 
-
+For nested runs, all versions posterior to \ttt{r1027} are broken.
 
 
 
 %% cas test THARSIS
-
-
+%% r1199 MESOSCALE. possibility to experiment simulations with Wee et al. 2012 changes in initialization (more consistent handling of hypsometric equation)
+%% run.def different if callphys different for nests
 
 
Index: trunk/MESOSCALE/MANUAL/SRC/faq.tex
===================================================================
--- trunk/MESOSCALE/MANUAL/SRC/faq.tex	(revision 1217)
+++ trunk/MESOSCALE/MANUAL/SRC/faq.tex	(revision 1218)
@@ -188,22 +188,12 @@
 \noindent \textbf{It seems difficult to me to find a number of horizontal grid points for parallel nested simulations that is compliant with all constraints mentioned in section~\ref{nests}.}
 \begin{finger}
-\item A tip to find a compliant domain size for nested simulations: for the parent domain, choose \ttt{e\_we} and \ttt{e\_sn} according to~$e_{we} = n_{proc} \times i + 1$ with~$n_{proc}$ being a multiple of~$4$ and~$2 \, i +1$ being a multiple of~$3$. For child domains, set \ttt{e\_we} and \ttt{e\_sn} according to \ttt{e\_we[child domain] = e\_we[parent domains] + 4}. 
-\end{finger}
-%%%%% TROP SPECIFIQUE !!!
-%%        -----------------------------------------------------------------------
-%%        -- si possible comment determiner taille ?
-%%        nproc doit diviser e_we-1 (1er nest)
-%%        grid_ratio doit diviser e_we-1 +4 (1er nest)
-%%        soit e_we=ye+1
-%%        grid_ratio divise ye+4 et nproc divise ye
-%%        soit nproc=8, ye=8*i
-%%        ainsi il existe j tel que 8i + 4 = 3j ou encore 4*[2i+1] = 3j
-%%        verifie par exemple si 2i+1 est multiple de 3
-%%        il suffit donc de trouver un multiple impair de 3 et de deduire i
-%%        par exemple 2i+1=33 >>>> i=16
-%%        >>>> e_we = 129 pour le 1er nest (et ajouter 4 pour les suivants)
-%%        ------------------------------------------------------------------------
-
-
+\item Here is a tip that allows to easily choose the number of horizontal grid points for parallel nested simulations. Let \ttt{e\_we} minus 1 be~$nn$. The three following conditions must be verified
+\begin{enumerate}
+\item the number of processors (usually 4) must divide~$nn$ for the mother domain
+\item same condition for~$nn+4$ in the nested domains
+\item \ttt{grid\_ratio} (usually 3) must divide~$nn+4$ for the nested domains
+\end{enumerate}
+With a standard number of 4 processors for nested runs, the second condition is verified if the first one is. The first and third conditions are verified if we make~$nn+4$ be a multiple of 12. Hence a very simple way to set the number of horizontal grid points \ttt{e\_we} and \ttt{e\_sn} in a nested simulation is to set the number of horizontal grid points in the nested domains as a multiple of 12 plus 1. The mother domain would then have this number of horizontal grid points minus 4. Examples: 117,121,121; 177,181,181; 57,61,61 \ldots
+\end{finger}
 
 %%% DIFFUSION FOR TRACERS