Index: /trunk/LMDZ.GENERIC/libf/phystd/watercommon_h.F90
===================================================================
--- /trunk/LMDZ.GENERIC/libf/phystd/watercommon_h.F90	(revision 1254)
+++ /trunk/LMDZ.GENERIC/libf/phystd/watercommon_h.F90	(revision 1255)
@@ -49,22 +49,22 @@
 ! JL12 variables for tetens formula
          real,parameter :: Pref_solid_liquid=611.14
-         real,parameter :: Trefvap=35.86
-         real,parameter :: Trefsub=7.66
+         real,parameter :: Trefvaporization=35.86
+         real,parameter :: Trefsublimation=7.66
          real,parameter :: Tmin=8.
-         real,parameter :: r3vap=17.269
-         real,parameter :: r3sub=21.875
+         real,parameter :: r3vaporization=17.269
+         real,parameter :: r3sublimation=21.875
 
 ! checked vs. old watersat data 14/05/2012 by JL.
 
          if (T.gt.T_h2O_ice_liq) then 
-            psat = Pref_solid_liquid*Exp(r3vap*(T-T_h2O_ice_liq)/(T-Trefvap)) ! liquid / vapour
-         else if (T.lt.Tmin) then
-            print*, "careful, T<Tmin in psat water"
-            !  psat = Pref_solid_liquid*Exp(r3sub*(Tmin-T_h2O_ice_liq)/(Tmin-Trefsub)) ! min psat  
-            ! Ehouarn: gfortran says: Error: Result of EXP underflows its kind,
-            !          so set psat to the smallest possible value instead
+            psat = Pref_solid_liquid*Exp(r3vaporization*(T-T_h2O_ice_liq)/(T-Trefvaporization)) ! liquid / vapour
+         else if (T.lt.Tmin) then
+	    print*, "careful, T<Tmin in psat water"
+          !  psat = Pref_solid_liquid*Exp(r3sublimation*(Tmin-T_h2O_ice_liq)/(Tmin-Trefsublimation)) ! min psat  
+         ! Ehouarn: gfortran says: Error: Result of EXP underflows its kind,
+         !          so set psat to the smallest possible value instead
             psat=tiny(psat)
          else                 
-            psat = Pref_solid_liquid*Exp(r3sub*(T-T_h2O_ice_liq)/(T-Trefsub)) ! solid / vapour
+            psat = Pref_solid_liquid*Exp(r3sublimation*(T-T_h2O_ice_liq)/(T-Trefsublimation)) ! solid / vapour
          endif
          if(psat.gt.p) then
@@ -105,28 +105,28 @@
 ! JL12 variables for tetens formula
          real,parameter :: Pref_solid_liquid=611.14
-         real,parameter :: Trefvap=35.86
+         real,parameter :: Trefvaporization=35.86
          real,parameter :: Tmin=8.
-         real,parameter :: Trefsub=7.66
-         real,parameter :: r3vap=17.269
-         real,parameter :: r3sub=21.875
+         real,parameter :: Trefsublimation=7.66
+         real,parameter :: r3vaporization=17.269
+         real,parameter :: r3sublimation=21.875
 
          real :: dummy
 
          if (psat.gt.p) then
-            dqsat=0.
-            return
-         endif
+	    dqsat=0.
+	    return
+	 endif
 
          if (T.gt.T_h2O_ice_liq) then
-            dummy = r3vap*(T_h2O_ice_liq-Trefvap)/(T-Trefvap)**2  ! liquid / vapour
-         else if (T.lt.Tmin) then
-            print*, "careful, T<Tmin in Lcp psat water"
-            dummy = r3sub*(T_h2O_ice_liq-Trefsub)/(Tmin-Trefsub)**2  ! solid / vapour
+            dummy = r3vaporization*(T_h2O_ice_liq-Trefvaporization)/(T-Trefvaporization)**2  ! liquid / vapour
+         else if (T.lt.Tmin) then
+	    print*, "careful, T<Tmin in Lcp psat water"
+            dummy = r3sublimation*(T_h2O_ice_liq-Trefsublimation)/(Tmin-Trefsublimation)**2  ! solid / vapour
          else               
-            dummy = r3sub*(T_h2O_ice_liq-Trefsub)/(T-Trefsub)**2  ! solid / vapour
+            dummy = r3sublimation*(T_h2O_ice_liq-Trefsublimation)/(T-Trefsublimation)**2  ! solid / vapour
          endif
 
          dqsat=RLVTT/RCPD*qsat*(p/(p-(1.-epsi)*psat))*dummy
-         dlnpsat=RLVTT/RCPD*dummy
+	 dlnpsat=RLVTT/RCPD*dummy
          return
       end subroutine Lcpdqsat_water
@@ -155,5 +155,4 @@
 !        input
          real p
-         real ra
   
 !        output
@@ -162,15 +161,13 @@
 ! JL12 variables for tetens formula
          real,parameter :: Pref_solid_liquid=611.14
-         real,parameter :: Trefvap=35.86
-         real,parameter :: Trefsub=7.66
-         real,parameter :: r3vap=17.269
-         real,parameter :: r3sub=21.875
-
-         ra = p/Pref_solid_liquid
+         real,parameter :: Trefvaporization=35.86
+         real,parameter :: Trefsublimation=7.66
+         real,parameter :: r3vaporization=17.269
+         real,parameter :: r3sublimation=21.875
 
          if (p.lt.Pref_solid_liquid) then ! solid / vapour
-            Tsat =(T_h2O_ice_liq*r3sub-Trefsub*Log(ra))/(r3sub-Log(ra))
+            Tsat =(T_h2O_ice_liq*r3sublimation- Trefsublimation*Log(p/Pref_solid_liquid))/(r3sublimation-Log(p/Pref_solid_liquid))
          else                 ! liquid / vapour
-            Tsat =(T_h2O_ice_liq*r3vap-Trefvap*Log(ra))/(r3vap-Log(ra))
+            Tsat =(T_h2O_ice_liq*r3vaporization- Trefvaporization*Log(p/Pref_solid_liquid))/(r3vaporization-Log(p/Pref_solid_liquid))
          endif
 
@@ -205,16 +202,16 @@
 ! JL12 variables for tetens formula
          double precision,parameter :: Pref_solid_liquid=611.14d0
-         double precision,parameter :: Trefvap=35.86D0
-         double precision,parameter :: Trefsub=7.66d0
+         double precision,parameter :: Trefvaporization=35.86D0
+         double precision,parameter :: Trefsublimation=7.66d0
          double precision,parameter :: Tmin=8.d0
-         double precision,parameter :: r3vap=17.269d0
-         double precision,parameter :: r3sub=21.875d0
+         double precision,parameter :: r3vaporization=17.269d0
+         double precision,parameter :: r3sublimation=21.875d0
 
 ! checked vs. old watersat data 14/05/2012 by JL.
 
          if (T.gt.T_h2O_ice_liq) then 
-            psat = Pref_solid_liquid*Exp(r3vap*(T-T_h2O_ice_liq)/(T-Trefvap)) ! liquid / vapour
-         else if (T.lt.Tmin) then
-            print*, "careful, T<Tmin in psat water"
+            psat = Pref_solid_liquid*Exp(r3vaporization*(T-T_h2O_ice_liq)/(T-Trefvaporization)) ! liquid / vapour
+         else if (T.lt.Tmin) then
+	    print*, "careful, T<Tmin in psat water"
          !   psat = Pref_solid_liquid*Exp(r3sublimation*(Tmin-T_h2O_ice_liq)/(Tmin-Trefsublimation)) ! min psat  
          ! Ehouarn: gfortran says: Error: Result of EXP underflows its kind,
@@ -222,5 +219,5 @@
             psat=tiny(psat)
          else                 
-            psat = Pref_solid_liquid*Exp(r3sub*(T-T_h2O_ice_liq)/(T-Trefsub)) ! solid / vapour
+            psat = Pref_solid_liquid*Exp(r3sublimation*(T-T_h2O_ice_liq)/(T-Trefsublimation)) ! solid / vapour
          endif
          if(psat.gt.p) then
@@ -261,28 +258,28 @@
 ! JL12 variables for tetens formula
          double precision,parameter :: Pref_solid_liquid=611.14d0
-         double precision,parameter :: Trefvap=35.86d0
+         double precision,parameter :: Trefvaporization=35.86d0
          double precision,parameter :: Tmin=8.d0
-         double precision,parameter :: Trefsub=7.66d0
-         double precision,parameter :: r3vap=17.269d0
-         double precision,parameter :: r3sub=21.875d0
+         double precision,parameter :: Trefsublimation=7.66d0
+         double precision,parameter :: r3vaporization=17.269d0
+         double precision,parameter :: r3sublimation=21.875d0
 
          double precision :: dummy
 
          if (psat.gt.p) then
-            dqsat=0.d0
-            return
-         endif
+	    dqsat=0.d0
+	    return
+	 endif
 
          if (T.gt.T_h2O_ice_liq) then
-            dummy = r3vap*(T_h2O_ice_liq-Trefvap)/(T-Trefvap)**2  ! liquid / vapour
-         else if (T.lt.Tmin) then
-            print*, "careful, T<Tmin in Lcp psat water"
-            dummy = r3sub*(T_h2O_ice_liq-Trefsub)/(Tmin-Trefsub)**2  ! solid / vapour
+            dummy = r3vaporization*(T_h2O_ice_liq-Trefvaporization)/(T-Trefvaporization)**2  ! liquid / vapour
+         else if (T.lt.Tmin) then
+	    print*, "careful, T<Tmin in Lcp psat water"
+            dummy = r3sublimation*(T_h2O_ice_liq-Trefsublimation)/(Tmin-Trefsublimation)**2  ! solid / vapour
          else               
-            dummy = r3sub*(T_h2O_ice_liq-Trefsub)/(T-Trefsub)**2  ! solid / vapour
+            dummy = r3sublimation*(T_h2O_ice_liq-Trefsublimation)/(T-Trefsublimation)**2  ! solid / vapour
          endif
 
          dqsat=RLVTT/RCPD*qsat*(p/(p-(1.d0-epsi)*psat))*dummy
-         dlnpsat=RLVTT/RCPD*dummy
+	 dlnpsat=RLVTT/RCPD*dummy
          return
       end subroutine Lcpdqsat_waterDP
Index: /trunk/LMDZ.GENERIC/makegcm_gfortran
===================================================================
--- /trunk/LMDZ.GENERIC/makegcm_gfortran	(revision 1254)
+++ /trunk/LMDZ.GENERIC/makegcm_gfortran	(revision 1255)
@@ -27,9 +27,7 @@
 #setenv LMDGCM "/san/home/rdword/gcm/LMDZ.GENERIC"
 setenv LIBOGCM $LMDGCM/libo
-## NetCDF, on LMD computers:
-#setenv NCDFLIB /donnees/emlmd/netcdf64-4.0.1_gfortran/lib
-#setenv NCDFINC /donnees/emlmd/netcdf64-4.0.1_gfortran/include
-setenv NCDFLIB /home/aymeric/Science/MODELES/LMDZ.COMMON/netcdf/gfortran_netcdf-4.0.1/lib
-setenv NCDFINC /home/aymeric/Science/MODELES/LMDZ.COMMON/netcdf/gfortran_netcdf-4.0.1/include
+# NetCDF, on LMD computers:
+setenv NCDFLIB /donnees/emlmd/netcdf64-4.0.1_gfortran/lib
+setenv NCDFINC /donnees/emlmd/netcdf64-4.0.1_gfortran/include
 #####
 